echo off

:: usage for tools 'wbJRFtools_ngram2class'
:: 	-count : input the count files,corresponding to the 'wsj.lext' vocabulary
::	-tag-vocab : the vocab containing class information. 
::	-features : output features files
::	-order : maximum order of features.
:: 	-addclass : add 'c'. 'w' is added default.
:: 	-add-word-jump : add 'ws'
::	-add-class-jump :add 'cs'
::	-add-skip2w : add 'hws'
::	-add-skip2c : add 'hcs'
::	-add-cpw : add 'cpw'

set order=4
set count=corpus\training.count
set tagv=corpus\wsj_c200.vocab

rem generate festure set 'w+c+ws+cs'
set name=%order%gram_c200_min_wj_cj
..\tools\wbJRFtools_ngram2class -count %count% -tag-vocab %tagv% -features %name%.feat -order %order% -addclass -add-word-jump -add-class-jump

rem generate feature set 'w+c+ws+cs+wsh+csh'
set name=%order%gram_c200_min_wj_cj_ws2_cs2
..\tools\wbJRFtools_ngram2class -train corpus/training.id -count %count% -tag-vocab %tagv% -features %name%.feat -order %order% -addclass -add-word-jump -add-class-jump -add-skip2w -add-skip2c

rem generate feature set 'w+c+ws+cs+cpw'
set name=%order%gram_c200_min_wj_cj_cpw
..\tools\wbJRFtools_ngram2class -count %count% -tag-vocab %tagv% -features %name%.feat -order %order% -addclass -add-word-jump -add-class-jump -add-cpw

pause