echo off

rem mini-batch number
set batch=300  
rem fixed to 1
set a0_lambda=1
rem set for learning rate in equ.(18)(19)
set beta_lambda=0.6
set beta_zeta=0.6

rem set for iteration number 
set t0=10000
set tmax=15000

rem feature files
set feat=4gram_c200_min_wj_cj_cpw

rem output name
set name=%~n0
set name=%name:~1%

rem test files
set test=..\corpus\test.id.bin
set train=..\corpus\training.id.bin
set valid=..\corpus\valid.id.bin

rem run, to train TDRF
::	-vocab : the vocabulary of TDRF models
::  -tag-vocab : the vocabulary containing the class information
::	-train : the training corpus, binary files.
::	-valid : the developing corpus, binary files. To determinate the stop time.
::	-test  : the test corpus, binary files. Just used to calculate the log-likelihood during iteration.
::	-model : output TDRF models
::	-log   : output the log files, containing some iteration information
::	-max-len : the maximum length of the TDRF models, which should be set to the maximum length of training and test corpus.
::  -iter-a0-lambda : should be set to 1
::	-iter-beta-lambda : beta_lambda in equ.(18)
::	-iter-beta-zeta : beta_zeta in equ.(19)
::	-iter-r-zeta : should be less than 1, such as 0.1
::	-iter-t0     : t0
::	-iter-max 	 : maximum iteration number
:: 	-min-batch	 : mini-batch
:: 	-title       : show the title on the top of cmd window.
:: 	-thread	     : thread number
::  -tconst		 : t_c in equ.(29)
::	-hgap		 : h in equ.(28)
:: 	-fast		 : a necessary label. perform the SAMS to estimate the TDRF models.
:: 	-iter-auto	 : denote that automatically stop the iteration
::	-iter-auto-rate : once the rising percentage of the smoothed log-likelihoods within 100 iterations is below 20\%, and then continue (t_max-t0) further iterations before stopping. 
::	-iter-reg 	: L2 regularization constants.

..\..\tools\wbJRFSAmodel_CHM -vocab ..\corpus\wsj.list -tag-vocab ..\corpus\wsj_c200.vocab -train %train% -valid %valid% -test %test% -feat ..\%feat%.feat -model %name%.model -log %name%.log -max-len 82 -iter-a0-lambda %a0_lambda% -iter-beta-lambda %beta_lambda% -iter-beta-zeta %beta_zeta% -iter-t0 %t0% -min-batch %batch% -title %name% -iter-max %tmax% -thread 2 -iter-r-zeta 0.1 -tconst 3000 -hgap 1e-4 -fast -iter-auto -iter-auto-rate 0.2 -iter-regular 1e-5


pause