// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Copyright 2014-2015 Tsinghua University
// Author: wb.th08@gmail.com (Bin Wang), ozj@tsinghua.edu.cn (Zhijian Ou) 
//
// \file
// Transform the txt corpus to Binary corpus
// All h, cpp, cc, and script files (e.g. bat, sh, pl, py) should include the above 
// license declaration. Different coding language may use different comment styles.


/**
 * \dir
 * \author wangbin
 * \date 2014-03-18
 * \todo ϣidתΪƣٶȡĳһУɳģÿռֽͬ
 * \brief ϣidתΪƣٶȡĳһУɳģÿռֽͬ
*/
/**
 * \file
 * \author wangbin
 * \date 2014-03-18
 * \brief [main]
 */
#include "wbSystem.h"
#include "wbSystem.cpp"
#include "JRF\wbJRFdef.h"

static char *cfg_pathTxt = NULL;
static char *cfg_pathBin = NULL;
static char *cfg_model = NULL;

wbOption options[] = {
	{wbOPT_STRING, "txt", &cfg_pathTxt, "txt corpus"},
	{wbOPT_STRING, "bin", &cfg_pathBin, "bin corpus"},
	{wbOPT_STRING, "mod", &cfg_model, "t2b(default) or b2t, ѡıתΪƣǶתı"}
};

void t2b();
void b2t();

_wbMain
{
	wbOpt_Parse(options);

	if (cfg_model==NULL || strcmp(cfg_model, "t2b")==0) {
		t2b();
	} else if (strcmp(cfg_model, "b2t") == 0) {
		b2t();
	} else {
		lout_error("unknown -mod = "<<cfg_model);
	}

	return 1;
};

void b2t()
{
	wbFile fileTxt(cfg_pathTxt, "wt");
	wbJRF::Corpus corpus(cfg_pathBin);

	lout<<"Transform Bin to Txt..."<<endl;
	titlePrecent(0, true, corpus.m_nLine, "Transform");
	for (int i=0; i<corpus.m_nLine; i++) {
		wbArray<int> aSeq;
		corpus.GetLine(i, aSeq);

		for (int n=0; n<aSeq.GetNum(); n++) {
			fileTxt.Print("%d ", aSeq[n]);
		}
		fileTxt.Print("\n");
		titlePrecent(i+1);
	}

}

void t2b()
{
	wbFile fileTxt(cfg_pathTxt, "rt");
	wbFile fileBin(cfg_pathBin, "wb");

	char *pLine;

	lout<<"Scan corpus txt..."<<endl;
	int nMaxLen = 0;
	int nTotalLine = 0;
	wbArray<int> aSeqBeg;
	int nSumLen = 0;
	while (pLine = fileTxt.GetLine(true)) {
		if ( strlen(pLine) <= 0 )
			continue;

		int nLen = 0;
		char *p = strtok(pLine, " \t");
		while (p) {
			nLen++;
			p = strtok(NULL, " \t");
		}

		nMaxLen = max(nMaxLen, nLen);
		nTotalLine++;
		aSeqBeg.Add(nSumLen);
		nSumLen += nLen;
	}
	aSeqBeg.Add(nSumLen);
	lout_variable(nTotalLine);
	lout_variable(nMaxLen);
	lout_variable(aSeqBeg.GetNum());

	fileTxt.Reset();
	fwrite(&nTotalLine, sizeof(int), 1, fileBin); /// дļͷ
	fwrite(&nMaxLen, sizeof(int), 1, fileBin);	/// дļͷ󳤶ȣ
												/// ÿռnMaxLen+1Intռ䣬Ϊһгȵı־
	///дۼӳ
	fwrite(aSeqBeg.GetBuffer(), sizeof(int), nTotalLine+1, fileBin);

	lout<<"Transform Txt to Bin..."<<endl;
	wbArray<int> aSeq(nMaxLen);
	while (pLine = fileTxt.GetLine(true)) {
		if ( strlen(pLine) <= 0 )
			continue;

		aSeq.Clean();
		aSeq.Fill(-1); ///-1
		char *p = strtok(pLine, " \t");
		while (p) {
			aSeq.Add(atoi(p));
			p = strtok(NULL, " \t");
		}

		int nLen = aSeq.GetNum();

		//fwrite(&nLen, sizeof(int), 1, fileBin); /// д뱾еĳ
		fwrite(aSeq.GetBuffer(), sizeof(int), nLen, fileBin); /// дУnMaxLenĿռմ
		
	}
}