// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Copyright 2014-2015 Tsinghua University
// Author: wb.th08@gmail.com (Bin Wang), ozj@tsinghua.edu.cn (Zhijian Ou) 
//
// \file
// Transform the .lext vocabulary (Used by SRILM toolkits) to .list vocabulary (Used by TDRF models).
// All h, cpp, cc, and script files (e.g. bat, sh, pl, py) should include the above 
// license declaration. Different coding language may use different comment styles.


/**
 * \dir
 * \author wangbin
 * \date 2014-03-19
 * \todo lextֵתΪRFģõlistʽֵ䣬ȥʼ0
 * \brief lextֵתΪRFģõlistʽֵ䣬ȥʼ0
*/
/**
 * \file
 * \author wangbin
 * \date 2014-03-19
 * \brief [main]
 */
#include "wbSystem.h"
#include "wbSystem.cpp"
#include "wbVocab.h"

static char *cfg_pathLext = NULL;
static char *cfg_pathList = NULL;

wbOption options[] = {
	{wbOPT_STRING, "lext", &cfg_pathLext, "lextʽֵ䣨ʼ"},
	{wbOPT_STRING, "list", &cfg_pathList, "listʽֵ䣬ʼ0ʼ"}
};

_wbMain
{
	wbOpt_Parse(options);

	wbVocab v;
	v.ReadT(cfg_pathLext);

	wbFile file(cfg_pathList, "wt");

	for (int i=2; i<v.aWords.GetNum(); i++) {
		file.Print("%d\t%s\n", i-2, v.aWords[i].GetBuffer());
	}

	return 1;
};