/**
 * \dir
 * \author wangbin
 * \date 2014-11-17
 * \todo NgramCountļȡ class modelfeatureʼģдļ(ҪϢֵ)
 * \brief NgramCountļȡ class modelfeatureʼģдļ(ҪϢֵ)
*/
/**
 * \file
 * \author wangbin
 * \date 2014-11-17
 * \brief [main]
 */

#include "wbSystem.h"
//#include "wbSystem.cpp"
#include "JRF\wbJRFMLmodel.h"
using namespace wbJRF;

static char *cfg_pathCount = NULL;
static int cfg_nIDoffset = 0;
static char *cfg_pathFeatures = NULL;
static int cfg_nOrder = 10;
// static bool cfg_bAddBegEndGramFeatures = false;
// static char *cfg_pathLenSegment = NULL;

static char *cfg_pathTraining = NULL; ///< ѵϣָϿִΪ0
//static int cfg_nCutoff = 0; 
static char *cfg_pathTagVocab = NULL; /// Ϣб

static bool cfg_bRMwordngram = false;
static bool cfg_bClass = false;
static bool cfg_bPartMixClass = false;
static bool cfg_bFullMixClass = false;

static bool cfg_bWordJump = false;
static bool cfg_bClassJump = false;

static bool cfg_bAddcpw = false;
static bool cfg_bAddcpwJump = false;

static bool cfg_bAddBegEnd = false;

static bool cfg_bAddSkipWBigram = false;
static bool cfg_bAddSkipCBigram = false;
static int cfg_nSkipMinOrder = 5;
static int cfg_nSkipMaxOrder = 6;

static int cfg_aCutoff[10] = {0}; //cutoff 

static bool cfg_bSort = false;

wbOption option[] = {
	{wbOPT_STRING, "count", &cfg_pathCount, "countļ(ڴ<s></s>,˴ʺŻtrainid2һҪ >= order+2"},
	{wbOPT_INT, "offset", &cfg_nIDoffset, "offset of the id in count files"},
	{wbOPT_STRING, "tag-vocab", &cfg_pathTagVocab, "ÿΪtoken-id word-id class-idָᴴclass"},
	{wbOPT_STRING, "features", &cfg_pathFeatures, "Write the init model file"},
	{wbOPT_INT, "order", &cfg_nOrder, "order of the features"},
 	{wbOPT_STRING, "train", &cfg_pathTraining, "ѵ(JRF-id)ָϿִΪ0"},
// 	{wbOPT_INT, "cut-off", &cfg_nCutoff, "<=cut-offᱻĬ0"}
	{wbOPT_TRUE, "rmword", &cfg_bRMwordngram, "remove word n-gram"},
	{wbOPT_TRUE, "addclass", &cfg_bClass, "add class n-gram"},
	{wbOPT_TRUE, "partmixclass", &cfg_bPartMixClass, "add partial mix class"},
	{wbOPT_TRUE, "fullmixclass", &cfg_bFullMixClass, "add full mix class"},
	{wbOPT_TRUE, "add-beg-end", &cfg_bAddBegEnd, "add beg-end"},
	{wbOPT_TRUE, "add-word-jump", &cfg_bWordJump, "add word jump ngram features"},
	{wbOPT_TRUE, "add-class-jump", &cfg_bClassJump, "add class jump ngram features"},
	{wbOPT_TRUE, "add-cpw", &cfg_bAddcpw, "add f(c,c,c,w)"},
	{wbOPT_TRUE, "add-cpw-jump", &cfg_bAddcpwJump, "add f(c,-1,-1,w)"},
	{wbOPT_TRUE, "add-skip2w", &cfg_bAddSkipWBigram, "add f(w, -1,-1,-1,-1, w),Ҫṩ"},
	{wbOPT_TRUE, "add-skip2c", &cfg_bAddSkipCBigram, "add f(c, -1,-1,-1,-1, w)"},
	{wbOPT_INT, "gt1min", &cfg_aCutoff[1], "curoff setting for order 1 features (features less than gt1min will be cut)"},
	{wbOPT_INT, "gt2min", &cfg_aCutoff[2], "curoff setting for order 2 features (features less than gt2min will be cut)"},
	{wbOPT_INT, "gt3min", &cfg_aCutoff[3], "curoff setting for order 3 features (features less than gt3min will be cut)"},
	{wbOPT_INT, "gt4min", &cfg_aCutoff[4], "curoff setting for order 4 features (features less than gt4min will be cut)"},
	{wbOPT_INT, "gt5min", &cfg_aCutoff[5], "curoff setting for order 5 features (features less than gt5min will be cut)"},
	{wbOPT_INT, "gt6min", &cfg_aCutoff[6], "curoff setting for order 6 features (features less than gt6min will be cut)"},
	{wbOPT_INT, "gt7min", &cfg_aCutoff[7], "curoff setting for order 7 features (features less than gt7min will be cut)"},
	{wbOPT_INT, "gt8min", &cfg_aCutoff[8], "curoff setting for order 8 features (features less than gt8min will be cut)"},
	{wbOPT_INT, "gt9min", &cfg_aCutoff[9], "curoff setting for order 9 features (features less than gt9min will be cut)"},
	{wbOPT_TRUE, "sort", &cfg_bSort, "sort the features"}
};

wbTrie<int, int> cfg_wordngram; //еwordNgram¼
Vocab cfg_vocab;
MLmodel *cfg_pModel = NULL;

//wbArray<Ngram*> cfg_aNgramFeatures; ///< ngramToken
wbHeap<Ngram*, int> cfg_ngramHeap(HEAPMODE_MINHEAP); //ngramcfg_aFeatruesıţݳִ
wbArray<Ngram*> cfg_aSortedNgram; ///< ngramcfg_aFeatrueеı
wbArray<int> cfg_aSortedCount; ///< ngramcount
wbArray<Ngram*> cfg_aFeatures; ///< Ҫӽ

void LoadCount(const char *pathCount); //Countеݶcfg_wordngram
void HeapNgram(Ngram *pFeat, int nCount);
void AddWordNgram(); //wordngram
void AddClassNgram(); //classngram
void AddWordClassNgram(); //word_class
void Addcpw(); /// f(c,c,c,w)
void AddSkip2w();
void AddSkip2c();

//¼feature
static wbTrie<int, int> cfg_featHash; ///< hash
void GetFeatureIndex(Ngram *pfeat, int *pIndex, int& nlen);
bool bFindInsert(Ngram *pfeat);

//count the empircal number of features
bool CountFeat(int *pCount);

_wbMain
{
	wbOpt_Parse(option);

	cfg_vocab.LoadVocabInfo(cfg_pathTagVocab);
	cfg_pModel = new MLmodel(&cfg_vocab, 100);

	lout<<"Load Count"<<endl;
	LoadCount(cfg_pathCount);

	//ngram
	Ngram *pFeat;
	int nCount;
	cfg_aSortedNgram.Clean();
	cfg_aSortedCount.Clean();
	while (cfg_ngramHeap.OutTop(pFeat, nCount)) {
		cfg_aSortedNgram.Add(pFeat);
		cfg_aSortedCount.Add(nCount);
	}
	
	//ձcfg_aFeatures
	
	if ( cfg_bClass ) {
		lout<<"Add Class Ngram"<<endl;
		AddClassNgram();
	}
	if ( cfg_bFullMixClass || cfg_bPartMixClass ) {
		lout<<"Add Word-Class Ngram"<<endl;
		AddWordClassNgram();
	}
	lout<<"Add Word Ngram"<<endl;
	AddWordNgram(); //wordڼclassʱɾ

	if ( cfg_bAddSkipWBigram ) {
		lout<<"Add Skip2w gram"<<endl;
		AddSkip2w();
	}
	if ( cfg_bAddSkipCBigram ) {
		lout<<"Add Skip2c gram"<<endl;
		AddSkip2c();
	}

	if ( cfg_bAddcpw || cfg_bAddcpwJump ) {
		lout<<"Add cpw Gram"<<endl;
		Addcpw();
	}

	//ļ
	cfg_pModel->CleanFeatures();
	SAFE_NEW_ARRAY(cfg_pModel->m_aFeatures, Feature*, cfg_aFeatures.GetNum());
	SAFE_NEW_ARRAY(cfg_pModel->m_aValues, double, cfg_aFeatures.GetNum());
	for (int i=0; i<cfg_aFeatures.GetNum(); i++) {
		if ( cfg_aFeatures[i] )
			cfg_pModel->AddFeature(cfg_aFeatures[i]);
	}
	cfg_aFeatures.Clean();
	for (int i=0; i<cfg_pModel->m_nFeatNum; i++) {
		cfg_aFeatures[i] = (Ngram*)cfg_pModel->m_aFeatures[i];
	}

	lout_variable(cfg_aFeatures.GetNum());
	lout_variable(cfg_pModel->m_nFeatNum);
	

	//cut-features
	int nCutNum = 0;
	wbArray<int> aCount(cfg_aFeatures.GetNum()+1);
	if ( true == CountFeat(aCount.GetBuffer()) ) {
		lout<<"Cut features..."<<endl;
		cfg_pModel->m_nFeatNum = 0;
		cfg_pModel->CleanFeatures();
		SAFE_NEW_ARRAY(cfg_pModel->m_aFeatures, Feature*, cfg_aFeatures.GetNum());
		SAFE_NEW_ARRAY(cfg_pModel->m_aValues, double, cfg_aFeatures.GetNum());
		for (int i=0; i<cfg_aFeatures.GetNum(); i++) {
			if ( cfg_aFeatures[i] ) {
				int nOrder = cfg_aFeatures[i]->order;
				if ( aCount[i] < cfg_aCutoff[nOrder] ) {
					SAFE_DELETE(cfg_aFeatures[i]);
					nCutNum++;
				} else {
					cfg_pModel->AddFeature(cfg_aFeatures[i]);
				}
			}
		}
	}
	lout_variable_precent(nCutNum, cfg_aFeatures.GetNum());
	lout_variable(cfg_pModel->m_nFeatNum);
	

	// Sort features
	if ( cfg_bSort ) {
		lout<<"Sort features"<<endl;
		wbHeap<Ngram*, int> sortHeap(HEAPMODE_MAXHEAP);
		for (int i=0; i<cfg_aFeatures.GetNum(); i++) {
			sortHeap.Insert(cfg_aFeatures[i], aCount[i]);
		}

		cfg_pModel->m_nFeatNum = 0;
		cfg_pModel->CleanFeatures();
		SAFE_NEW_ARRAY(cfg_pModel->m_aFeatures, Feature*, cfg_aFeatures.GetNum());
		SAFE_NEW_ARRAY(cfg_pModel->m_aValues, double, cfg_aFeatures.GetNum());
		Ngram *pNgram; 
		int nCount;
		while (sortHeap.OutTop(pNgram, nCount)) {
			cfg_pModel->AddFeature(pNgram, (double)nCount);
		}
	}
	
	// Write features
	lout<<"Write Features"<<endl;
	cfg_pModel->WriteFeatures(wbFile(cfg_pathFeatures, "wt"));

	//ɾ
	for (int nSort=0; nSort<cfg_aSortedNgram.GetNum(); nSort++)
		SAFE_DELETE(cfg_aSortedNgram[nSort]);
		
	return 1;
};

void LoadCount(const char *pathCount)
{
	wbFile file(pathCount, "rt");
	char *pLine;
	while (pLine = file.GetLine())
	{
		wbArray<int> aSeq;

		bool bBeg = false;
		bool bEnd = false;

		char *p = strtok(pLine, " \t");
		while (p) {
			if (strstr(p, "<s>")) {  //пʼͽĶֱӣͨsuperGram
				bBeg = true;
			} else if (strstr(p, "</s>")) {
				bEnd = true;
			} else {
				aSeq.Add(atoi(p) + cfg_nIDoffset); //ngramֵJRFֵ䲻ͬJRFֵûΪʼţid-2
			}
			p = strtok(NULL, " \t");
		}

		int nOrder = aSeq.GetNum()-1;
		int nCount = aSeq.End()+2;
		aSeq.m_nTop--; //ȥһΪ

		if (nOrder <= 0)
			continue;
		if (nOrder > cfg_nOrder)
			continue;

		//ngramͬ
		if (bBeg==false && bEnd==false)  //ǿʼҲǽΪͨ
			HeapNgram(new Ngram(aSeq, nOrder), nCount);
		else if (bBeg==true && bEnd==false && nOrder <= cfg_nOrder - 1)  //ӿʼԼ
			HeapNgram(new SuperNgram(aSeq, nOrder, 0, INT_MAX, 0, 0), nCount);
		else if (bBeg==false && bEnd==true && nOrder <= cfg_nOrder - 1)  //ӽԼ
			HeapNgram(new SuperNgram(aSeq, nOrder, 0, INT_MAX, -1, -1), nCount);
// 		else if (bBeg==true && bEnd==true && nOrder <= cfg_nOrder - 2)
// 			HeapNgram(new SuperNgram(aSeq, nOrder, nOrder, nOrder, 0, 0), nCount);

		//ӿʼʵǸһ׵ngram
		if (cfg_bAddBegEnd) {
			if (bBeg == true && bEnd == false && nOrder == cfg_nOrder )
				HeapNgram(new SuperNgram(aSeq, nOrder, 0, INT_MAX, 0, 0), nCount);
			else if (bBeg == false && bEnd == true && nOrder == cfg_nOrder)
				HeapNgram(new SuperNgram(aSeq, nOrder, 0, INT_MAX, -1, -1), nCount);
// 			else if (bBeg == true && bEnd == true && nOrder >= cfg_nOrder-1)
// 				HeapNgram(new SuperNgram(aSeq, nOrder, nOrder, nOrder, 0, 0), nCount);
		}
		
	}
}
void HeapNgram(Ngram *pFeat, int nCount)
{
	cfg_ngramHeap.Insert(pFeat, nCount);
}
// void AddFeature(Ngram *pFeat)
// {
// 	int idx[50];
// 	int len;
// 	bool bFound;
// 	GetFeatureIndex(pFeat, idx, len);
// 	cfg_featHash.Insert(idx, len, bFound);
// 	if ( !bFound ) {
// 		cfg_aFeatrues.Add(pFeat);
// 	}
// }

void GetFeatureIndex(Ngram *pfeat, int *pIndex, int& nlen)
{
	//ԳλԼGramԼһ
	if ( pfeat->type == ngram || pfeat->type == jgram ) {
		pIndex[0] = 0;
		pIndex[1] = INT_MAX;
		pIndex[2] = 0;
		pIndex[3] = pos_tail;
	} else {
		SuperNgram *p = (SuperNgram*)pfeat;
		pIndex[0] = p->len_min;
		pIndex[1] = p->len_max;
		pIndex[2] = p->pos_min;
		pIndex[3] = p->pos_max;
	}

	cfg_pModel->GetGramIndex(pfeat, pIndex+4);

	nlen = 4 + pfeat->order;
}
bool bFindInsert(Ngram *pfeat)
{
	int idx[10];
	int len;
	GetFeatureIndex(pfeat, idx, len);
	int *p = cfg_featHash.Find(idx, len);
	if ( !p ) { //ûҵ
		*cfg_featHash.Insert(idx, len) = 1; //һҪֵ
		return false;
	}
	return true;
}


void AddWordNgram()
{
	int wids[10];
	for (int nSort=0; nSort<cfg_aSortedNgram.GetNum(); nSort++)
	{
		Ngram *pNgram =cfg_aSortedNgram[nSort];
		if (pNgram==NULL)
			continue;

		int nOrder = pNgram->order;
		//word ids
		for (int i=0; i<nOrder; i++)
			wids[i] = cfg_vocab.aVocabInfo[ pNgram->flag[i] ].wid;
		//WordNgram
		WordNgram *pWord = new WordNgram(cfg_vocab.aVocabInfo, wids, nOrder);
		if ( pNgram->type == super ) 
			pWord->CopyExConstaints((SuperNgram*)pNgram);

		//жǷڣֹظ
		if ( bFindInsert(pWord) ||
			cfg_aSortedCount[nSort] < cfg_aCutoff[nOrder] ) {
			SAFE_DELETE(pWord);
			continue;
		}

		//
		cfg_aFeatures.Add(pWord);

		//word-jump
		if ( cfg_bWordJump ) 
		{
			//ÿλõjumpܣֻjump
			for (int jump_num=1;  jump_num <=nOrder-2; jump_num++) {//jumpĸ
				for (int jump_pos=1; jump_pos <=nOrder-1-jump_num; jump_pos++) { //jumpλ
					//ȳʼԭʼ
					for (int i=0; i<nOrder; i++)
						wids[i] = cfg_vocab.aVocabInfo[ pNgram->flag[i] ].wid;
					//jump 
					for (int i=jump_pos; i<jump_pos + jump_num; i++) {
						wids[i] = VocabID_none;
					}
					
					//WordNgram
					WordNgram *pWord = new WordNgram(cfg_vocab.aVocabInfo, wids, nOrder);
					if ( pNgram->type == super ) 
						pWord->CopyExConstaints((SuperNgram*)pNgram);
					//жǷڣֹظ
					if ( bFindInsert(pWord) ) {
						SAFE_DELETE(pWord);
						continue;
					}
					//
					cfg_aFeatures.Add(pWord);
				}
			}
		}
	}
}

void AddClassNgram()
{
	int cids[10];
	for (int nSort=0; nSort<cfg_aSortedNgram.GetNum(); nSort++) //еngram
	{
		Ngram *pNgram = cfg_aSortedNgram[nSort];
		if (pNgram==NULL)
			continue;

		int nOrder = pNgram->order;
		//class ids
		for (int i=0; i<nOrder; i++)
			cids[i] = cfg_vocab.aVocabInfo[ pNgram->flag[i] ].cid;
		//ClassNgram
		ClassNgram *pClass = new ClassNgram(cfg_vocab.aVocabInfo, cids, nOrder);
		if (pNgram->type == super) {
			pClass->CopyExConstaints((SuperNgram*)pNgram);
		}
		//жǷڣֹظ
		if ( bFindInsert(pClass) ) {
			SAFE_DELETE(pClass);
			continue;
		}

		//Ҫɾһngram
		cfg_aFeatures.Add(pClass);
		//ngramģ˽ɾǰĵһngram
		if ( cfg_bRMwordngram ) {
			SAFE_DELETE(cfg_aSortedNgram[nSort]);
		}

		//class-jump
		if ( cfg_bClassJump ) 
		{
			//ÿλõjumpܣֻjump
			for (int jump_num=1;  jump_num <=nOrder-2; jump_num++) {//jumpĸ
				for (int jump_pos=1; jump_pos <=nOrder-1-jump_num; jump_pos++) { //jumpλ
					//ȳʼԭʼ
					for (int i=0; i<nOrder; i++)
						cids[i] = cfg_vocab.aVocabInfo[ pNgram->flag[i] ].cid;
					//jump 
					for (int i=jump_pos; i<jump_pos + jump_num; i++) {
						cids[i] = VocabID_none;
					}

					//WordNgram
					ClassNgram *pClass = new ClassNgram(cfg_vocab.aVocabInfo, cids, nOrder);
					if ( pNgram->type == super ) 
						pClass->CopyExConstaints((SuperNgram*)pNgram);
					//жǷڣֹظ
					if ( bFindInsert(pClass) ) {
						SAFE_DELETE(pClass);
						continue;
					}
					//
					cfg_aFeatures.Add(pClass);
				}
			}
		} // bClassJump
	}
}

void AddWordClassNgram()
{
	for (int nSort=0; nSort<cfg_aSortedNgram.GetNum(); nSort++) //еngram
	{
		Ngram *pNgram = cfg_aSortedNgram[nSort];
		if (pNgram==NULL)
			continue;

		int nOrder = pNgram->order;
		if ( nOrder <= 1 )
			continue;

		//ȷĸλҪΪclass
		int cposBeg = 0;
		if ( cfg_bPartMixClass ) cposBeg = nOrder-1;
		if ( cfg_bFullMixClass ) cposBeg = 0;
		for (int cpos=cposBeg; cpos<nOrder; cpos++)
		{
			//feature
			GlobalNgram *pGlobal = new GlobalNgram(cfg_vocab.aVocabInfo);
			pGlobal->order = nOrder;
			for (int i=0; i<nOrder; i++) {
				if ( i != cpos ) {//wordϢ
					pGlobal->flag[i] = (pNgram->flag[i]==VocabID_none)? VocabID_none: cfg_vocab.aVocabInfo[ pNgram->flag[i] ].wid;
					pGlobal->cflag[i] = VocabID_none;
				} else { // classϢ
					pGlobal->flag[i] = VocabID_none;
					pGlobal->cflag[i] =(pNgram->flag[i]==VocabID_none)? VocabID_none: cfg_vocab.aVocabInfo[ pNgram->flag[i] ].cid;
				}
			}
			if (pNgram->type == super) {
				pGlobal->CopyExConstaints((SuperNgram*)pNgram);
			}

			//жǷڣֹظ
			if ( bFindInsert(pGlobal) ) {
				SAFE_DELETE(pGlobal);
				continue;
			}

			//Ҫɾһngram
			cfg_aFeatures.Add(pGlobal);
			//ngramģ˽ɾǰĵһngram
			if ( cfg_bRMwordngram ) {
				SAFE_DELETE(cfg_aSortedNgram[nSort]);
				break; //ǰngramѾһGlobal˵ǰngramѾɾˣ֤Ŀֲ
			}
		}
	}
}

void Addcpw()
{
	for (int nSort=0; nSort<cfg_aSortedNgram.GetNum(); nSort++) //еngram
	{
		Ngram *pNgram = cfg_aSortedNgram[nSort];
		if (pNgram==NULL)
			continue;

		int nOrder = pNgram->order;
		if ( nOrder <= 1 )
			continue;

		
		
		//feature
		GlobalNgram *pGlobal = new GlobalNgram(cfg_vocab.aVocabInfo);
		pGlobal->order = nOrder;
		for (int i=0; i<nOrder; i++) {
			if ( i<nOrder-1 ) {//classϢ
				pGlobal->cflag[i] = (pNgram->flag[i]==VocabID_none)? VocabID_none: cfg_vocab.aVocabInfo[ pNgram->flag[i] ].cid;
				pGlobal->flag[i] = VocabID_none;
			} else { ///word
				pGlobal->cflag[i] = VocabID_none;
				pGlobal->flag[i] =(pNgram->flag[i]==VocabID_none)? VocabID_none: cfg_vocab.aVocabInfo[ pNgram->flag[i] ].wid;
			}
		}
		if (pNgram->type == super) {
			pGlobal->CopyExConstaints((SuperNgram*)pNgram);
		}

		if ( pGlobal->Is_cpw() == false) {
			lout_error("cpw gramȷ!!!");
		}

		//жǷڣֹظ
		if ( bFindInsert(pGlobal) ) {
			SAFE_DELETE(pGlobal);
			continue;
		}

		//
		cfg_aFeatures.Add(pGlobal);

		//jump
		if ( cfg_bAddcpwJump ) 
		{
			//ÿλõjumpܣֻjump
			for (int jump_num=1;  jump_num <=nOrder-2; jump_num++) {//jumpĸ
				for (int jump_pos=1; jump_pos <=nOrder-1-jump_num; jump_pos++) { //jumpλ
					//feature
					pGlobal = new GlobalNgram(cfg_vocab.aVocabInfo);
					pGlobal->order = nOrder;
					for (int i=0; i<nOrder; i++) {
						if ( i<nOrder-1 ) {//classϢ
							pGlobal->cflag[i] = (pNgram->flag[i]==VocabID_none)? VocabID_none: cfg_vocab.aVocabInfo[ pNgram->flag[i] ].cid;
							pGlobal->flag[i] = VocabID_none;
						} else { ///word
							pGlobal->cflag[i] = VocabID_none;
							pGlobal->flag[i] =(pNgram->flag[i]==VocabID_none)? VocabID_none: cfg_vocab.aVocabInfo[ pNgram->flag[i] ].wid;
						}
					}
					//jump 
					for (int i=jump_pos; i<jump_pos + jump_num; i++) {
						pGlobal->cflag[i] = VocabID_none;
						pGlobal->flag[i] = VocabID_none;
					}

					if ( pNgram->type == super ) 
						pGlobal->CopyExConstaints((SuperNgram*)pNgram);
					//жǷڣֹظ
					if ( bFindInsert(pGlobal) ) {
						SAFE_DELETE(pGlobal);
						continue;
					}
					//
					cfg_aFeatures.Add(pGlobal);
				}
			}
		}

	}
}

void AddSkip2w()
{
	lout_variable(cfg_nSkipMinOrder);
	lout_variable(cfg_nSkipMaxOrder);

	int gram[10];
	int nTotal = 0;
	
	wbFile file(cfg_pathTraining, "rt");
	lout<<"Add SkipBigramWord"<<endl;
	char *pLine;
	while (pLine = file.GetLine(true)) {
		wbArray<int> aIds;

		char *p = strtok(pLine, " \t");
		while (p) {
			aIds.Add( atoi(p) );
			p = strtok(NULL, " \t");
		}

		if ( aIds.GetNum() == 0 )
			continue;

		int nLen = aIds.GetNum();
		for(int order=cfg_nSkipMinOrder; order<=cfg_nSkipMaxOrder; order++) {
			for (int pos=0; pos<=nLen-order; pos++) {
				for (int i=0; i<10; i++)
					gram[i] = VocabID_none;
				gram[0] = cfg_vocab.aVocabInfo[ aIds[pos] ].wid;
				gram[order-1] = cfg_vocab.aVocabInfo[ aIds[pos+order-1] ].wid;

				//WordNgram
				WordNgram *pWord = new WordNgram(cfg_vocab.aVocabInfo, gram, order);

				//жǷڣֹظ
				if ( bFindInsert(pWord) ) {
					SAFE_DELETE(pWord);
					continue;
				}
				//
				cfg_aFeatures.Add(pWord);
				nTotal++;
			}
		}
	}
	lout<<"Add Skip2w = "<<nTotal<<endl;

}

void AddSkip2c()
{
	lout_variable(cfg_nSkipMinOrder);
	lout_variable(cfg_nSkipMaxOrder);

	int gram[10];
	int nTotal = 0;

	wbFile file(cfg_pathTraining, "rt");
	lout<<"Add SkipBigramWord"<<endl;
	char *pLine;
	while (pLine = file.GetLine(true)) {
		wbArray<int> aIds;

		char *p = strtok(pLine, " \t");
		while (p) {
			aIds.Add( atoi(p) );
			p = strtok(NULL, " \t");
		}

		if ( aIds.GetNum() == 0 )
			continue;

		int nLen = aIds.GetNum();
		for(int order=cfg_nSkipMinOrder; order<=cfg_nSkipMaxOrder; order++) {
			for (int pos=0; pos<=nLen-order; pos++) {
				for (int i=0; i<10; i++)
					gram[i] = VocabID_none;
				gram[0] = cfg_vocab.aVocabInfo[ aIds[pos] ].cid;
				gram[order-1] = cfg_vocab.aVocabInfo[ aIds[pos+order-1] ].cid;

				//WordNgram
				ClassNgram *pClass = new ClassNgram(cfg_vocab.aVocabInfo, gram, order);

				//жǷڣֹظ
				if ( bFindInsert(pClass) ) {
					SAFE_DELETE(pClass);
					continue;
				}
				//
				cfg_aFeatures.Add(pClass);
				nTotal++;
			}
		}
	}
	lout<<"Add Skip2c = "<<nTotal<<endl;

}


bool CountFeat(int *pCount)
{

	int nMaxCutoff = 0;
	for (int i=0; i<10; i++) {
		nMaxCutoff = max(nMaxCutoff, cfg_aCutoff[i]);
	}
	if ( !cfg_bSort && nMaxCutoff <= 0 ) {
		return false;
	}

	cfg_pModel->PrepareInitModel(false);
	lout<<"Count features"<<endl;
	memset( pCount, 0, sizeof(pCount[0])*(cfg_pModel->m_nFeatNum) );

	if ( cfg_pathTraining == NULL ) {
		lout_error("Need the training corpus (id)");
	}
	wbFile file(cfg_pathTraining, "rt");
	char *pLine;
	while (pLine = file.GetLine(true))
	{
		wbArray<int> aIds;

		char *p = strtok(pLine, " \t");
		while (p) {
			aIds.Add( atoi(p) );
			p = strtok(NULL, " \t");
		}

		if ( aIds.GetNum() == 0 )
			continue;

		int nLen = aIds.GetNum();

		wbArray<int> aFeatures;
		
				cfg_pModel->FindFeatures(aFeatures, aIds.GetBuffer(), nLen);
				for (int i=0; i<aFeatures.GetNum(); i++) {
					pCount[ aFeatures[i] ] += 1.0;
				}
		

	}

	wbFile fileCount(wbString(cfg_pathFeatures)+".count", "wt");
	for (int i=0; i<cfg_pModel->m_nFeatNum; i++) {
		fileCount.Print("%d\n", pCount[i]);
	}
	fileCount.Close();

	return nMaxCutoff > 0;
}