// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Copyright 2014-2015 Tsinghua University
// Author: wb.th08@gmail.com (Bin Wang), ozj@tsinghua.edu.cn (Zhijian Ou) 
//
// \file
// Large Txt file read and write class
// All h, cpp, cc, and script files (e.g. bat, sh, pl, py) should include the above 
// license declaration. Different coding language may use different comment styles.



/**
  * \file
  * \brief LargeFile࣬ʹöreadܴıļ
  * \author wangbin
  * \date 2013-8-29
  * \note ıʽҪʹöֽڱ룬ıļҪתGB2312ʽʹü±ΪѡASCIʽ
  * - ڳ4GļҪʹ_fseeki64 _ftelli64ȡλãΪlong longͣдʱֻʹfreadfwrite
  * - дļʱͨ
*/

#pragma once
#include "wbFile.h"


const size_t c_default_blackSize = 10*1024*1024; ///< ļСܳ4G10M, Է֣1M1GӰٶ
const size_t c_max_read_blockSize = UINT_MAX; ///< readһܶļС4Gapi
const size_t c_max_write_blockSize = 500*1024*1024; ///< writeһдݴС4Gapi
/**
  * \class wbLargeFile

*/
class wbLargeFile
{
public:
	FILE *m_fp;					///< ļָ
	long long m_llFileSize;		///< ļСֽ
	size_t m_nBlockSize;	///< һԶ/дֽڴС
	long long m_llProcessedSize;		///< Ѿֽ

	char *m_pBuf;				///< safe the memory buffer
	char *m_pCur;				///< buffer еݴλ
	char *m_pLine;				///<  ÿ仰buffer

	char m_mode[5];				///< ģʽ'rt'ļ'wt'дļ, 'rb', 'wb'
	int m_nLine;				///< ¼,1ʼ
public:
	wbLargeFile(void):m_fp(NULL),m_pBuf(NULL),m_pCur(NULL),m_pLine(NULL){};
	wbLargeFile(const char *path, const char *pmode, size_t nBlockSize = c_default_blackSize):
	m_fp(NULL),m_pBuf(NULL),m_pCur(NULL),m_pLine(NULL)
	{
		Open(path, pmode, nBlockSize);
	}
	~wbLargeFile(void)
	{
		//رļ
		if (m_fp)
			Close();
		m_fp = NULL;

		//ͷſռ
		if (m_pBuf)
			delete [] m_pBuf;
		m_pBuf = NULL;

		if (m_pLine)
			delete [] m_pLine;
		m_pLine = NULL;
	}

	/// ļΪ˺wbFile
	/**
	  * \param [in] path Ҫļ
	  * \param [in] pmode 򿪷ʽrt/wt/rb/wb,ʵڲʹöƸʽ򿪵
	  * \param [in] nBlockSize һԶļСֽڣ
	*/
	void Open(const char *path, const char *pmode, size_t nBlockSize = c_default_blackSize)
	{
		if ( strcmp(pmode, "rt") == NULL ) {
			OpenRead(path, nBlockSize);
		} else if ( strcmp(pmode, "wt") == NULL ) {
			OpenWrite(path, nBlockSize);
		} else {
			strcpy(m_mode, pmode);
			SAFE_FOPEN(m_fp, path, pmode);
		}
	}
	/// 򿪶ļlargeFileȫʹöƸʽ򿪵ļ
	/**
	  * \param [in] path Ҫļ
	  * \param [in] nBlockSize һԶļСֽڣ
	*/
	void OpenRead(const char *path, size_t nBlockSize = c_default_blackSize)		
	{ 
		SAFE_FOPEN(m_fp, path, "rb"); 
		strcpy(m_mode, "rt");

		m_llFileSize = GetFileSize();
		m_nBlockSize = min((long long)nBlockSize, m_llFileSize);
		m_llProcessedSize = 0;

		m_pBuf = new char[m_nBlockSize + 1];
		m_pCur = m_pBuf + m_nBlockSize;
		*m_pCur = '\0';

		m_nLine = 0;
	}
	/// ȡһbuffer,ļβ򷵻false
	bool GetBufData()
	{
		if (m_llProcessedSize >= m_llFileSize) { //Ѿ
			return false;
		}
		long long llReadSize = min((long long)m_nBlockSize, m_llFileSize-m_llProcessedSize);
		m_pCur = m_pBuf + m_nBlockSize - llReadSize; //ʹúllReadSizeBuffer
		fread(m_pCur, llReadSize, 1, m_fp);
		m_pCur[llReadSize] = '\0';

		m_llProcessedSize += llReadSize;
		return true;
	}
	/// һ
	bool GetLine( char *pLine )
	{
		if (*m_pCur == '\0' && m_llProcessedSize >= m_llFileSize)
			return false;

		char *pLineStart = pLine;
		m_nLine++;

		while (1) 
		{
			for (; *m_pCur!='\0'; m_pCur++) {

				if (*m_pCur == '\n') {
					*pLine = '\0';
					m_pCur++;

					//windowµıļУ\r\n
					if (pLine > pLineStart && *(pLine-1)=='\r')
						*(pLine-1) = '\0';
					
					return true;
				}

				*pLine++ = *m_pCur;

				//ܻһйGS_SENTENCE_LEN
				if (pLine - pLineStart >= GS_SENTENCE_LEN-1)
				{
					lout_warning("nline="<<m_nLine<<" Too Long!");
					*pLine = '\0';
					///һ
					while (1) 
					{
						for (; *m_pCur!='\0' && *m_pCur !='\n'; m_pCur++) { //ҵз
						}
						m_pCur++;
						if ( *m_pCur == '\0' ) {
							//ʣѾһ
							//һµblock
							if (false == GetBufData())
								break;
						} else {
							break;
						}
					}
					return true;
				}
			}

			if ( *m_pCur == '\0' ) {
				//ʣѾһ
				//һµblock
				if ( false == GetBufData() ) { //Ѿ
					*pLine = '\0';
					return true;
				}
// 				if (m_llProcessedSize >= m_llFileSize) { //Ѿ
// 					*pLine = '\0';
// 					return true;
// 				}
// 				long long llReadSize = min((long long)m_nBlockSize, m_llFileSize-m_llProcessedSize);
// 				m_pCur = m_pBuf + m_nBlockSize - llReadSize; //ʹúllReadSizeBuffer
// 				fread(m_pCur, llReadSize, 1, m_fp);
// 				m_pCur[llReadSize] = '\0';
// 
// 				m_llProcessedSize += llReadSize;
			} else  {
				break;
			}
		}

		return true;
		
	}
	/// һ
	bool GetLine( char *pLine, bool bPrecent )
	{
		if (m_llProcessedSize == 0)
			wbTitle::Precent(0, true, m_llFileSize, "LargeFileRead: ");

		bool bOk = GetLine(pLine);

		wbTitle::Precent( m_llProcessedSize-m_nBlockSize+(m_pCur-m_pBuf) );

		return bOk;
	}
	/// һ
	char *GetLine( bool bPrecent = false ) 
	{
		if (m_pLine == NULL) 
			m_pLine = new char[GS_SENTENCE_LEN];

		if (bPrecent && m_llProcessedSize == 0)
			wbTitle::Precent(0, true, m_llFileSize, "LargeFileRead: ");

		if (false == GetLine( m_pLine ))
			return NULL;

		if (bPrecent)
			wbTitle::Precent( m_llProcessedSize-m_nBlockSize+(m_pCur-m_pBuf) );
		return m_pLine;
	}
	/// дļlargeFileȫʹöƸʽļ
	/**
	  * \param [in] path Ҫдļ
	  * \param [in] nBlockSize һдļСֽڣ
	*/
	void OpenWrite(const char *path, size_t nBlockSize = c_default_blackSize)	
	{ 
		SAFE_FOPEN(m_fp, path, "wb"); 
		strcpy(m_mode, "wt");

		m_nBlockSize = nBlockSize;
		m_llProcessedSize = 0;

		m_pBuf = new char[m_nBlockSize+1];
		m_pCur = m_pBuf;

		m_nLine = 0;
	}

	/// ַ
	void Putc( char c )
	{
		if (m_pCur >= m_pBuf + m_nBlockSize) {
			fwrite(m_pBuf, m_nBlockSize, 1, m_fp);
			m_pCur = m_pBuf;
		}
		*m_pCur++ = c;
	}
	/// дַ
	void Puts( const char *pStr ) 
	{
		const char *pStrHead = pStr;

		while(*pStr != '\0')
		{
			//window£ıÿнβҪһзһسӻз
			if (*pStr == '\n') {
				m_nLine++;
				if ( pStr==pStrHead || *(pStr-1) != '\r' ) {
					Putc('\r');
				}
			}

			Putc(*pStr++);
		}
	}
	///ڽβӻس
	void PutLine(char *pLine)
	{
		Puts(pLine);
		Putc('\n');
	}
	/// ʽ
	void Print(const char* p_pMessage,...)
	{
		char strBuffer[GS_SENTENCE_LEN];
		va_list vaParams;
		va_start(vaParams,p_pMessage);
		_vsnprintf(strBuffer,GS_SENTENCE_LEN,p_pMessage,vaParams);

		Puts(strBuffer);
	}
	/// ջ棬ȫдļ
	void Flush()
	{
		size_t nSize = m_pCur-m_pBuf;
		if (nSize > 0) {
			fwrite(m_pBuf, nSize, 1, m_fp);
			m_pCur = m_pBuf;
		}
	}

	/// ļС
	long long GetFileSize()
	{
		long long llcur = _ftelli64(m_fp);
		_fseeki64(m_fp, 0, SEEK_END);
		long long llsize = _ftelli64(m_fp);
		_fseeki64(m_fp, llcur, SEEK_SET);
		return llsize;
	}

	/// ļ
	void Reset()
	{
		_fseeki64(m_fp, 0, SEEK_SET);
		
		if ( strcmp(m_mode, "rt")==NULL ) {
			m_pCur = m_pBuf + m_nBlockSize;
			*m_pCur = '\0';
		} else if ( strcmp(m_mode, "wt")==NULL ){
			m_pCur = m_pBuf;
		}

		m_llProcessedSize = 0;
		m_nLine = 0;
	}

	///رļ
	void Close() 
	{
		if (strcmp(m_mode, "wt")==NULL)
			Flush();
		fclose(m_fp); 
	}

	///ƶ
	void Read(void *pBuf, size_t nSize, size_t nCount)
	{
		wbLargeFile::FRead(pBuf, nSize, nCount, m_fp);
	}

	/// д
	void Write(void *pBuf, size_t nSize, size_t nCount)
	{
		wbLargeFile::FWrite(pBuf, nSize, nCount, m_fp);
	}

	///ƶstatic
	static void FRead(void *pBuf, size_t nSize, size_t nCount, FILE *fp)
	{
		size_t nMaxCount = c_max_read_blockSize / nSize;

		char *pCurBuf = (char*)pBuf;
		size_t nLeftCount = nCount;
		while (nLeftCount > 0) {
			size_t nProCount = min(nMaxCount, nLeftCount);
			fread(pCurBuf, nSize, nProCount, fp);
			pCurBuf += nSize * nProCount;
			nLeftCount -= nProCount;
		}
	}
	
	/// дstatic
	static void FWrite(void *pBuf, size_t nSize, size_t nCount, FILE *fp)
	{
		size_t nMaxCount = c_max_read_blockSize / nSize;

		char *pCurBuf = (char*)pBuf;
		size_t nLeftCount = nCount;
		while (nLeftCount > 0) {
			//cout<<"Write Block"<<endl;
			size_t nProCount = min(nMaxCount, nLeftCount);
			fwrite(pCurBuf, nSize, nProCount, fp);
			pCurBuf += nSize * nProCount;
			nLeftCount -= nProCount;
		}
	}
};

