// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Copyright 2014-2015 Tsinghua University
// Author: wb.th08@gmail.com (Bin Wang), ozj@tsinghua.edu.cn (Zhijian Ou) 
//
// \file
// log class
// All h, cpp, cc, and script files (e.g. bat, sh, pl, py) should include the above 
// license declaration. Different coding language may use different comment styles.



#pragma once
#ifndef _WB_LOG_H_
#define _WB_LOG_H_

#include <iostream>
#include <fstream>
/**
 * \file
 * \author WangBin
 * \date 2013-08-29
 * \brief wbLog ṩͬʱĻlogļϢ
 * \note  wbLogʵĶΪ loutwbSystem.cppж
 * ʵ̬loutʹcoutһʹãloutص㣺
 *		1ͬʱlogļĻϢÿͨԿƣԹرĻϢ
 *		2ὫеĿʼͽʱ
 *		3޸ĶboolڣboolᱻԶתΪַ true/false
 *		4ӡַǣжָǷΪ
 *		5ṩ꣬ lout_variable Կٴӡ lout_error  lout_warning ṩ
*/
#include <ctime>
using namespace std;

#define wbLog_LevelSpace "\t"

#define wbLog_OutputSpace(io) \
	for (int i=0; i<m_nLevel; i++) io<<wbLog_LevelSpace;
#define wbLog_Output(x) \
	if (m_bOutputLog) { {wbLog_OutputSpace(m_fileLog)} m_fileLog<<x; } \
	if (m_bOutputCmd) { {wbLog_OutputSpace(cout)} cout<<x; }\
	return *this;

/**
 * \class wbLog
 * \author WangBin
 * \date 2013-8-29
 * \brief wbLog, ׼coutͬʱcmdlogļͬʱϢ
 * ĬlogļΪ .log
*/
class wbLog
{
protected:
	ofstream m_fileLog; ///< ļ
	bool m_bOutputLog; ///< Ƿlogļ
	bool m_bOutputCmd; ///< Ƿcmd

	short m_nLevel;  ///< ÿlevel׺
public:
	wbLog()
	{
		m_bOutputCmd = true;
		m_bOutputLog = true;
		m_nLevel = 0;

		char strFileName[255];
		strcpy(strFileName, strrchr(__argv[0], '\\')+1);
		char *p = strstr(strFileName, ".");
		if (p)
			strcpy(p, ".log");
		else
			strcat(strFileName, ".log");

		m_fileLog.open(strFileName, ios_base::app);
		if (!m_fileLog.good())
		{
			cout<<"Open Log file faled! ["<<strFileName<<"]"<<endl;
			exit(0);
		}


		char strTime[128];
		char strDate[128];
		_strdate(strDate);
		_strtime(strTime);
		m_fileLog<<endl;
		*this<<"[Begin]\t"<<strDate<<" "<<strTime<<endl;

	}
	~wbLog()
	{
		char strTime[128];
		char strDate[128];
		_strdate(strDate);
		_strtime(strTime);
		m_bOutputLog = true;
		m_bOutputCmd = true;
		*this<<"[End]\t"<<strDate<<" "<<strTime<<endl;
	}

	/// ¶λlogļbNewǷ´ļѴļݣ
	void ReFile(const char *path, bool bNew = true)
	{
		m_bOutputCmd = true;
		m_bOutputLog = true;
		m_nLevel = 0;

		m_fileLog.close();
		if (bNew)
			m_fileLog.open(path);
		else
			m_fileLog.open(path, ios_base::app);

		if (!m_fileLog.good())
		{
			cout<<"Open Log file faled! ["<<path<<"]"<<endl;
			exit(0);
		}

		char strTime[128];
		char strDate[128];
		_strdate(strDate);
		_strtime(strTime);
		m_fileLog<<endl;
		*this<<"[ReFile]  bNew = "<<bNew<<endl;
		*this<<"[Begin]\t"<<strDate<<" "<<strTime<<endl;
	}

	/// Ƿcmd
	bool &bOutputCmd() { return m_bOutputCmd; }
	/// Ƿlogļ
	bool &bOutputLog() { return m_bOutputLog; }

	wbLog &operator << ( ostream& (*op) (ostream&)) { wbLog_Output(*op) }
	wbLog &operator << (int x) { wbLog_Output(x) }
	wbLog &operator << (short x) { wbLog_Output(x) }
	wbLog &operator << (long x) { wbLog_Output(x) }
	wbLog &operator << (long long x) { wbLog_Output(x) }
	wbLog &operator << (unsigned int x) { wbLog_Output(x) }
	wbLog &operator << (unsigned short x) { wbLog_Output(x) }
	wbLog &operator << (unsigned long x) { wbLog_Output(x) }
	wbLog &operator << (float x) { wbLog_Output(x) }
	wbLog &operator << (double x) { wbLog_Output(x) }
	wbLog &operator << (char x) { wbLog_Output(x) }
	wbLog &operator << (const char* x) {
		//жָǷϷ
		if (x) {
			wbLog_Output(x)
		}
		else {
			wbLog_Output("[NULL]") 
		}
	}
	wbLog &operator << (const void* x) {
		//жָǷϷ
		if (x) {
			wbLog_Output(x)
		}
		else {
			wbLog_Output("[NULL]") 
		}
	}
	wbLog &operator << (bool x) {
		//boolתַӡ
		if (x) {
			wbLog_Output("true") 
		} else {
			wbLog_Output("false")
		}
	}
	/// һ
	void LevelDown() { m_nLevel++; } 
	/// 
	void LevelUp() { m_nLevel = (m_nLevel<=0)? 0: m_nLevel-1; } 

};


/// wbLogʵ, wbSystem.cpp
extern wbLog lout;


#define lout_variable(x) {lout<<#x" = "<<x<<endl;}
#define lout_variable_precent(x,y) {lout<<#x" = "<<x<<" ("<<100.0*(x)/(y)<<"%)  /"#y<<endl;}
#define lout_error(x) {lout.bOutputCmd()=true; lout<<"[ERROR] "<<x<<endl; exit(0);}
#define lout_warning(x) {lout<<"[WARNING] "<<x<<endl;}
#define lout_assert(p) {if(!(p)) lout_error("! ("#p")"); }

#define precent(x, n) (x)<<"("<<100.0*(x)/(n)<<"%)"


#endif