// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Copyright 2014-2015 Tsinghua University
// Author: wb.th08@gmail.com (Bin Wang), ozj@tsinghua.edu.cn (Zhijian Ou) 
//
// \file
// Thread class
// All h, cpp, cc, and script files (e.g. bat, sh, pl, py) should include the above 
// license declaration. Different coding language may use different comment styles.



#pragma once
#include "wbSystem.h"
#include <windows.h>

//#define _wbTHREAD_PRINT_INFO

//һǣⲿʼwbThreadMangerд,,Ҫ
class wbTaskPack
{
public:
	int nId; //ÿTaskҪӵһIDid֤ԣڴʱʹnId = m_nTaskNum++ֵ
	wbTaskPack( int id = 0 ):nId(id){};
	virtual ~wbTaskPack(){};
	//̴߳׶ε
	virtual bool Process(int nThreadId) { return true; };
};

/// ÿ̵߳Ĵ
struct wbThreadInfo
{
	int nId;
	HANDLE hThread;
	HANDLE hTaskAllockEvent;
	HANDLE hTaskFinishEvent;
	HANDLE hThreadExitEvent;
	wbTaskPack *pTaskPack;
	int nSeed; ///< 2014-3-20: ÿ̵߳ĳʼӡÿ̶߳ӣҪֱʼһ
};


//̹߳ҪҪCreateTask  FinishTask 
#define TM_FLAG_LEN 100
class wbThreadManager
{
public:
	char m_strFlag[TM_FLAG_LEN];

public: 
	
	int m_nThreadNum;

private:
	wbThreadInfo *m_pThreadInfo; //ÿ̵߳ʹ
	wbHeap<wbTaskPack*, int> *m_pTaskBuffer; //񻺴棬ŴTaskԱ֤
	int m_nCurTaskId; //ҪһTaskId

public:
	int m_nTaskNum; //ܹTaskĿ
public:
	virtual wbTaskPack* CreateTask();  //һnew ָ
	virtual void FinishTask( wbTaskPack *&pTask ); //ӡ

public:
	wbThreadManager(int p_nThreadNum, const char *p_flag="");
	~wbThreadManager(void);

	/*
	StartThread  EndThreadʹÿظRunһµ񣬶Ҫظ˳̡߳
	֤߳һֱڣֱEndThread.
	ȻµRunʱһҪReset֤bufպ͵ǰidĳʼ.
	*/

	///< ̵̣߳߳׼
	bool StartThread();
	///< CreateTaskΪ̴ֱ߳µ; ֹ̣߳Run̴߳waiting״̬
	bool Run();
	///< ̷߳͡˳ʹ߳˳ͬʱͷŵStartThreadпٵԴҪStartThreadӦ
	bool EndThread();
	///< bufferõǰidĿResetµRun
	void Reset() 
	{
		m_pTaskBuffer->Clean();
		m_nCurTaskId = 0;
		m_nTaskNum = 0;
	}

	///< ͷڴ棬ֻе
	void ReleaseThread();
	///< Ĵbuffer
	bool BufferTask( wbTaskPack *pTask ); //Task
public:
	static DWORD WINAPI ThreadProc(LPVOID lpThreadParameter);

	// lout
	/**
	ڲһ¼̵ֹ߳ĴӡϢһ
	Printf_Init  Printf_Release ʼͷŻ¼
	Print_Beg  Print_End ֮ӡϢ
	*/
	static HANDLE hLoutFinishedEvent;
	static void Printf_Init();
	static void Printf_Release();
	static void Print_Beg();
	static void Print_End();
	static void Printf(int nThreadId, const char* pFormat, ...);
	
};
