// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Copyright 2014-2015 Tsinghua University
// Author: wb.th08@gmail.com (Bin Wang), ozj@tsinghua.edu.cn (Zhijian Ou) 
//
// \file
// Thread manager class
// All h, cpp, cc, and script files (e.g. bat, sh, pl, py) should include the above 
// license declaration. Different coding language may use different comment styles.


#pragma once
#include "wbSystem.h"
#include <windows.h>
#include "wbConsole.h"
//һǣⲿʼwbThreadMangerд,,Ҫ
class wbTaskPack
{
public:
	virtual bool Process(int nThreadId) { return true; };
	virtual bool Release() { return true; }
};

class wbTPNode
{
public:
	wbTaskPack *pTask;
	int nId; //task id

	wbTPNode *pNext;
	wbTPNode *pPrev;
	bool bEnd;	//Ŀǰûʹõ˵뷨
				//bEndһ񣬿ǵ첽ģܻѽ; 
				//bEndǵ񲻴һӵ㣬û,ȽpTaskΪNULL
				//wbThreadManager::AddTaskEnd()սӵ

	wbTPNode() { pTask = NULL; pNext = NULL; pPrev = NULL; bEnd = false;}
};

struct wbThreadInfo
{
	int nId;
	HANDLE phThread;
	HANDLE phTaskAllockEvent;
	HANDLE phTaskFinishEvent;
	HANDLE phThreadExitEvent;
	wbTPNode *pTaskPack;
};

#define TM_FLAG_LEN 100
class wbThreadManager
{
public:
	char m_strFlag[TM_FLAG_LEN];
public: 
	wbThreadInfo *m_pThreadInfo;
	int m_nThreadNum;

	wbTPNode *m_pTaskHead; //ͷһڵ
	wbTPNode *m_pTaskTail; //βһڵ
	int m_nTaskTotalNum; //ֻҪtask
	int m_nTaskCurNum;	//ǰtask
public:
	//Console 
	static wbStdOutMager *s_pThreadOutMager;
public:
	wbThreadManager(int nThreadNum, const char *p_flag="");
	~wbThreadManager(void);

	bool AddTask(wbTaskPack *pTask);
	bool AddTaskEnd();
	bool DeleteTask(wbTPNode *pTaskNode);

	bool StartThread();
	bool Run();
public:
	static DWORD WINAPI ThreadProc(LPVOID lpThreadParameter);

	static void ThreadPrintf(int nThreadId, const char* pFormat, ...);
	static void MainPrintf(const char* pFormat, ...);
};


void tprintf(int nThreadId, const char* pFormat, ...);
void mprintf(const char* pFormat, ...);

void tprecent(int nThreadId, size_t n, bool bNew = false, size_t nTotal = 100, const char* title = "Process");
void tprecent(int nThreadId, FILE *fp, bool bNew = false, const char* title = "Process");
