// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Copyright 2014-2015 Tsinghua University
// Author: wb.th08@gmail.com (Bin Wang), ozj@tsinghua.edu.cn (Zhijian Ou) 
//
// \file
// Vector/Array class
// All h, cpp, cc, and script files (e.g. bat, sh, pl, py) should include the above 
// license declaration. Different coding language may use different comment styles.


/**
 * \file
 * \author WangBin
 * \date 2013-9-2
 * \brief 򵥵Ķ̬ջ
*/
#ifndef _WB_VECTOR_H_
#define _WB_VECTOR_H_
#include <conio.h> 

//#define DEFAULE_VECTOR_STEP 100


#define DEFAULE_VECTOR_SIZE 16
#define VECTOR_bits2Size(n) (1<<n)
template <typename T>
/**
 * \class wbVector
 * \author Wangbin
 * \brief Vector࣬ʵ鶯̬ڴƣǶ̬ࡢջࡢĻ
 * ڴ濪ٷʽ޸ģȥm_nBufferStepΪڴ*2Ĳԣڴ濪ٴ
*/
class wbVector
{
private:
	T *m_pBuffer; ///< bufferڴָ
public:
// 	int m_nBufferSize;
// 	int m_nBufferStep;
	int m_nBits;  ///< ǰڴı
public:
	/// 캯ٵڴ治ԶʼҪⲿֶʼֵ
	wbVector(int size = DEFAULE_VECTOR_SIZE/*, int step = DEFAULE_VECTOR_STEP*/)
	{
		m_pBuffer = NULL;
// 		m_nBufferSize = size;
// 		m_nBufferStep = step;
		m_nBits = Size2Bits(size);
		m_pBuffer = new T[VECTOR_bits2Size(m_nBits)];
		//ֵܸΪ0T=wbString丳ֵΪ0ڲָΪЧ˾޷ͷڴ棬صڴй¶
		//memset(m_pBuffer, 0, sizeof(T)*m_nBufferSize);
	}

	~wbVector()
	{
		if (m_pBuffer != NULL)
			delete []m_pBuffer;
		m_pBuffer = NULL;
		m_nBits = 0;
	}
	
	/// ÿڴĴС
	int Size() const { return VECTOR_bits2Size(m_nBits); }

	inline T* GetBuffer(int i=0) const { return m_pBuffer+i; }

	/// ĳλõֵڴ治㣬¿
	inline T& Get(int i)
	{
		/*wb,ֹiСnew 0ֽڵĴ*/
		if ( i<0 ) {
			i = 0;
		}

		int nSize = VECTOR_bits2Size(m_nBits);

		if ( i >= nSize ) //չڴ
		{
			int nNewBits = Size2Bits(i+1);

			T *pNew = new T[VECTOR_bits2Size(nNewBits)];
			//memset(pNew+m_nBufferSize, 0, sizeof(T)*nStepNum*m_nBufferStep);

			/*
			memcpy޸Ϊ=ֵΪʹwbStringչڴ
			memcpy(pNew, m_pBuffer, sizeof(T)*m_nBufferSize);
			*/
			for (int n=0; n<nSize; n++)
				pNew[n] = m_pBuffer[n];

			delete [] m_pBuffer;
			m_pBuffer = pNew;
			m_nBits = nNewBits;
		}

		return m_pBuffer[i];
	}

	/// sizeתұ
	inline int Size2Bits(int size)
	{
		for(int n=1; ; ++n) {
			if ( VECTOR_bits2Size(n) >= size)
				return n;
		}
		return 0;
	}

	/// bufferÿݾm
	/** ʹ=ֵԷֹcopyʱ= */
	void Fill(T m)
	{
		for (int i=0; i<VECTOR_bits2Size(m_nBits); i++)
			m_pBuffer[i] = m;
	}
	/// memsetڴ渳Ϊ0
	void Zero()
	{
		memset(m_pBuffer, 0, sizeof(T)*VECTOR_bits2Size(m_nBits));
	}

	/*
	copy,ҪĳЩֱʹmemcpy
	*/
	void Copy(const wbVector<T> &vector)
	{
		if (m_pBuffer==NULL) {
			m_nBits = vector.m_nBits;
			m_pBuffer = new T[VECTOR_bits2Size(m_nBits)];
		} else if ( m_nBits < vector.m_nBits ) {
			delete [] m_pBuffer;
			m_nBits = vector.m_nBits;
			m_pBuffer = new T[VECTOR_bits2Size(m_nBits)];
		}

		for (int i=0; i<VECTOR_bits2Size(vector.m_nBits); i++)
			m_pBuffer[i] = vector.m_pBuffer[i];
	}
	void MemCopy(wbVector<T> &vector)
	{
		if (m_pBuffer==NULL) {
			m_nBits = vector.m_nBits;
			m_pBuffer = new T[VECTOR_bits2Size(m_nBits)];
		} else if ( m_nBits < vector.m_nBits ) {
			delete [] m_pBuffer;
			m_nBits = vector.m_nBits;
			m_pBuffer = new T[VECTOR_bits2Size(m_nBits)];
		}

		memcpy(m_pBuffer, vector.m_pBuffer, sizeof(T)*VECTOR_bits2Size(m_nBits));
	}
	//ڲbuffⲿָ룬˷ʹúڲbuffָ뱻NULL
	void BufferOutside( T* &p_pt )
	{
		p_pt = m_pBuffer;
		m_pBuffer = NULL;
		new (this) wbVector();  //³ʼ
	}
};


/**
 * \class wbArray
 * \brief ࣺ ̬ 
 * \author WangBin
 * \note
	ʹô˶̬ʱa[i] = a[j]ڲȡǱ֤ijԽ磬ڵǰBufferSize	ڴ˹УijiѾԽ磬iʱ¿ڴ棬jصãʵǵַЧˡ
	ʱм̣
		temp = a[j];
		a[i] = temp;
	.һͬʱʶݣǱ֤ÿʶԽ硣
*/
template <typename T>
class wbArray : public wbVector<T>
{
public:
	int m_nTop; ///< 鶥С
public:
	wbArray(int size = DEFAULE_VECTOR_SIZE) : wbVector(size)
	{
		m_nTop = -1;
	}
	wbArray(wbArray &array) { Copy(array); }
	~wbArray() { m_nTop = -1; }
	T& operator [](int i)
	{
		if (i < 0) {
			cout<<"[warning]   i="<<i<<endl;
/*#ifdef _DEBUG*/
			getch();
/*#endif*/
			i = 0;
		}

		if (i > m_nTop)
			m_nTop = i;

		return Get(i);
	}

	/// Сͨȷڴ, SetNumͨmemcpyһԸֵ
	void SetNum(int n) { Get(n-1); m_nTop=n-1; }
	/// С
	int GetNum() const { return m_nTop+1; }
	/// һԪ
	void Add(T t) { (*this)[m_nTop+1] = t; }
	/// һԪ
	T& Add() { return (*this)[m_nTop+1]; }
	/// һЩԪ
	void Add(wbArray<T> &a) { for(int i=0; i<a.GetNum(); i++) { Add(a[i]); } }
	/// βԪ
	T& End() { return (*this)[m_nTop]; }
	/// 飬ڴ
	void Clean() { m_nTop = -1; }
	/// copyʹ=иֵ
	void Copy(const wbArray<T> &array)
	{
		wbVector<T>::Copy(array);
		m_nTop = array.m_nTop;
	}
	///  copyʹmemcpyиֵڼ򵥱
	void MemCopy(wbArray<T> &array)
	{
		wbVector<T>::MemCopy(array);
		m_nTop = array.m_nTop;
	}
	/// صȺ
	void operator = (const wbArray<T> &array) { Copy(array); }
	operator T* () { return GetBuffer(); }
};

/**
 * \class wbDArray
 * \brief λ飬ͨһάռʵֵ
 * \author WangBin
*/
template <typename T>
class wbDArray : public wbVector<T>
{
public:
	int m_nXDim;
	int m_nYDim;
	wbDArray(int x_size = DEFAULE_VECTOR_SIZE, int y_size = DEFAULE_VECTOR_SIZE) : wbVector(x_size*y_size)
	{
		m_nXDim = x_size;
		m_nYDim = y_size;
	}

	T& Get(int i, int j)
	{
		return wbVector::Get(i*m_nYDim+j);
	}
};

/**
 * \class wbStack
 * \brief ջ
 * \author Wangbin
*/
template <typename T>
class wbStack : public wbVector<T>
{
public:
	int m_nTop; ///<ջ

	wbStack(int size = DEFAULE_VECTOR_SIZE) : wbVector(size)
	{
		m_nTop = 0;
	}

	void Clean() { m_nTop = 0; }
	
	void Push(T p_t)
	{
		Get(m_nTop) = p_t;
		m_nTop++;
	}
	bool Pop(T *p_pT) 
	{ 
		if (m_nTop == 0) 
			return false; 

		if (p_pT != NULL)
			*p_pT = Get(m_nTop-1);

		m_nTop--;
		return true;
	}
	T Top() 
	{ 
		if (m_nTop == 0) 
			return Get(0); 
		return Get(m_nTop-1); 
	}
	int GetNum() const { return m_nTop; }
};

/**
 * \class wbQueue
 * \brief 
 * \author WangBin
 * \note ⲻһѭУӳӵĽУеĿռԽԽ
*/
template <typename T>
class wbQueue : public wbVector<T>
{
public:
	int m_nTop;
	int m_nBottom;

	wbQueue(int size = DEFAULE_VECTOR_SIZE) : wbVector(size)
	{
		m_nTop = 0;
		m_nBottom = 0;
	}

	void Clean() { m_nTop = 0; m_nBottom = 0; }

	
	void In(T p_t)
	{
		Get(m_nTop) = p_t;
		m_nTop++;
	}
	bool Out(T *p_pT)
	{
		if (m_nBottom == m_nTop)
			return false;
		if (p_pT)
			*p_pT = Get(m_nBottom);
		m_nBottom++;
		return true;
	}
	bool IsEmpty()
	{
		return m_nBottom == m_nTop;
	}

	int GetNum() {return m_nTop - m_nBottom; }
};


/**
 * \class wbCirQueue
 * \brief ѭ
 * \author WangBin
 * \note ѭ
*/
template <typename T>
class wbCirQueue : wbVector<T>
{
private:
	int nSize;
	bool bFull;
public:
	int nHead;
	int nTail;
	
public:
	wbCirQueue(int size = 10):wbVector<T>(size)
	{
		nHead = 0;
		nTail = 0;
		bFull = false;
		nSize = size;
	}
	void Init(int size)
	{
		Clean();
		Get(size);
		nSize = size;
	}
	void Clean()
	{
		nHead = 0;
		nTail = 0;
		bFull = false;
	}

	void In(T t)
	{
		if ( !bFull ) {
			Get(nTail) = t;
			nTail = (nTail+1)%nSize;
			if ( nTail == nHead )
				bFull = true;
		} else {
			Out();
			In(t);
		}
	}
	bool Out(T *t = NULL)
	{
		if (!bFull) {
			if ( nHead == nTail ) {
				// empty
				return false;
			} else {
				if (t) *t = Get(nHead);
				nHead = (nHead+1)%nSize;
				return true;
			}
		} else {
			if (t) *t = Get(nHead);
			nHead = (nHead+1)%nSize;
			bFull = false;
			return true;
		}
	}
	bool IsEmpty() { return (!bFull) && nHead == nTail; }
	bool IsFull() { return bFull; }
	int GetNum() { return (bFull)? nSize: max(nTail-nHead, nTail+nSize-nHead); }
	int GetSize() { return nSize; }
	T GetSum()
	{
		T sum = 0;
		if ( bFull ) {
			for (int i=0; i<nSize; i++)
				sum += Get(i);
		} else {
			for (int i=nHead; i != nTail; i=(i+1)%nSize)
				sum += Get(i);
		}
		return sum;
	}
};

/**
 * \class wbVec
 * \brief һЩõ
 * \author WangBin
 * \note һЩõ
*/
template <typename T>
class wbVec
{
public:
	static double Norm(T *pVec, int len)
	{
		double sum = 0;
		for (int i=0; i<len; i++) {
			sum += pVec[i] * pVec[i];
		}
		return sqrt(sum);
	}
	static double Dot(T *pVec1, T *pVec2, int len)
	{
		double sum = 0;
		for (int i=0; i<len; i++) {
			sum += pVec1[i] * pVec2[i];
		}
		return sum;
	}
	static double Diff(T *pVec1, T*pVec2, int len)
	{
		double sum = 0;
		for (int i=0; i<len; i++) {
			sum += pow(pVec1[i]-pVec2[i], 2);
		}
		return sqrt(sum);
	}
	static double Angle(T *pVec1, T* pVec2, int len)
	{
		double sum = Dot(pVec1, pVec2, len);
		return sum / Norm(pVec1, len) / Norm(pVec2, len);
	}
};


#endif